/* vi:set cindent: */
#include <nwconio.h>
#include <nwsnut.h>
#include <nwadv.h>

char *messages[] =
{
  "Sample NWSNUT application",
  "v1.0"
};

char *unloadtext = "Press any key to terminate this module";

int
main ()
{
  int screen;
  LONG tag;
  NUTInfo *nuthandle;
  LONG portal;
  PCB *pcb;

  screen = CreateScreen ("Sample NWSNUT application",
			 AUTO_DESTROY_SCREEN |
			 DONT_CHECK_CTRL_CHARS);

  if (screen == NULL)
    {
      ConsolePrintf ("\rtestnut: CreateScreen failed.\n");
      exit (1);
    }

  SetCurrentScreen (screen);
  DisplayScreen (screen);

  tag = AllocateResourceTag (GetNLMHandle (),
			     (BYTE *) "NWSNUT Alloc Tag",
			     AllocSignature);

  if (!tag)
    {
      ConsolePrintf ("\rtestnut: AllocateResourceTag failed.\n");
      exit (1);
    }

  if (NWSInitializeNut (0,
			1,
			NORMAL_HEADER,
			NUT_REVISION_LEVEL,
			(BYTE **) messages,
			0,
			screen,
			tag,
			&nuthandle))
    {
      ConsolePrintf ("\rtestnut: Can't initialize NWSNUT\n");
      exit (1);
    }

  portal = NWSCreatePortal (10,        /* line */
			    5,         /* column */
			    7,         /* frame height */
			    70,        /* frame width */
			    6,         /* virtual height */
			    80,        /* virtual width */
			    NO_SAVE,   /* save flag */
			    (BYTE *) "Program information", /* header text */
			    VNORMAL,   /* header attribute */
			    DOUBLE,    /* border type */
			    VINTENSE,  /* border attributes */
			    CURSOR_OFF,/* cursor flag */
			    DIRECT,    /* direct flag */
			    nuthandle  /* nutinfo handle */
			    );

  if (portal > MAXPORTALS)
    {
      ConsolePrintf ("\rtestnut: Can't create NWSNUT portal.\n");
      exit (1);
    }

  NWSGetPCB (&pcb,
	     portal,
	     nuthandle);

  NWSClearPortal(pcb);
  NWSShowPortalLine(1,
	  15,
	  unloadtext,
	  strlen(unloadtext),
	  pcb);

  NWSUpdatePortal(pcb);
  NWSSelectPortal(pcb, nuthandle);
  
  getch ();
  
  NWSRestoreNut(nuthandle);
  DestroyScreen(screen);

  return 0;
}
